<?xml version="1.0" encoding="UTF-8"?>
<launch>
  <arg name="veh" default="labdrone" />
  <arg name="num" default="01" />
  <arg name="jsdev" default="js0" /> <!-- joystick dev path -->
  <arg name="room" default="" /> <!-- override mit room bounds -->

  <!-- Publish previously captured nest poses -->
  <node name="pub_nest_poses" pkg="labdrone" type="pub_nest_poses.py" output="screen" />

  <!-- visualization -->
  <node name="rvizlabdrone" pkg="rviz" type="rviz" args="-d $(find labdrone)/config/default.rviz" />

  <!-- Trajectory generation server -->
  <node pkg="polytraj_ros" type="server" name="polytraj_server" output="screen">
    <!-- trajectory generation parameters -->
    <rosparam param="vmax">[0.5,0.5,0.5]</rosparam>
    <rosparam param="amax">[0.8,0.8,0.8]</rosparam>
  </node>

  <!-- Joystick (hardware) -->
  <group ns="$(arg veh)$(arg num)" unless="$(eval arg('jsdev') == 'sim')">
    <node pkg="joy" type="joy_node" name="joystick" output="screen">
        <param name="dev" type="string" value="/dev/input/$(arg jsdev)" />
        <param name="dev_ff" value="" />
        <param name="deadzone" value="0.18" />
        <param name="autorepeat_rate" value="100" />
    </node>
  </group>

  <!-- Keyboard (simulation) -->
  <group ns="$(arg veh)$(arg num)" if="$(eval arg('jsdev') == 'sim')">
    <node pkg="acl_joy" type="vimfly.py" name="vimfly">
      <param name="vx_cmd" value="0.5" />
      <param name="vy_cmd" value="0.5" />
      <param name="vz_cmd" value="0.5" />
      <param name="psidot_cmd" value="1.5708" />
    </node>
  </group>

  <group if="$(eval arg('room') == 'mit')">
    <!-- Typically, you would just change the room bounds set by mocap pkg -->
    <!-- but since MIT flight space is used for multiple projects, those -->
    <!-- bounds are set conservatively. -->
    <!-- This makes room bounds a little less so for the nest transaction. -->
    <rosparam ns="room_bounds">
      x_min: -4.25
      x_max: 4.5
      y_min: -4.0
      y_max: 4.25
      z_min: 0.0
      z_max: 2.0
    </rosparam>
  </group>

   
</launch>
